VERSION 5.00
Begin VB.UserControl ProgressBar 
   Alignable       =   -1  'True
   Appearance      =   0  'Flat
   ClientHeight    =   630
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3375
   ScaleHeight     =   42
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   225
End
Attribute VB_Name = "ProgressBar"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Private Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function MoveWindow Lib "user32" (ByVal hwnd As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Private Declare Function SetWindowPos Lib "user32" (ByVal hwnd As Long, ByVal hWndInsertAfter As Long, ByVal x As Long, ByVal y As Long, ByVal cx As Long, ByVal cy As Long, ByVal wFlags As SWP_PARAMS) As Long
Private Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hwnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Private Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long

Private Const PROGRESS_CLASS As String = "msctls_progress32"
Private Const WS_CHILD As Long = &H40000000
Private Const WS_VISIBLE As Long = &H10000000
Private Const WS_BORDER As Long = &H800000
Private Const WS_CLIPSIBLINGS As Long = &H4000000

Private Const GWL_STYLE As Long = -16
Private Const GWL_EXSTYLE As Long = -20

Private Const WS_EX_CLIENTEDGE As Long = &H200&
Private Const CLR_DEFAULT As Long = &HFF000000

Private Enum SWP_PARAMS
  SWP_NOSIZE = &H1&
  SWP_NOMOVE = &H2&
  SWP_NOZORDER = &H4&
  SWP_NOREDRAW = &H8&
  SWP_NOACTIVATE = &H10&
  SWP_FRAMECHANGED = &H20&
  SWP_SHOWWINDOW = &H40&
  SWP_HIDEWINDOW = &H80&
  SWP_NOCOPYBITS = &H100&
  SWP_NOOWNERZORDER = &H200&
  SWP_NOSENDCHANGING = &H400&
  SWP_DEFERERASE = &H2000&
  SWP_ASYNCWINDOWPOS = &H4000&
End Enum

Private Const WM_USER As Long = &H400&
Private Enum PBM_PARAMS
  PBS_SMOOTH = &H1&
  PBS_VERTICAL = &H4&
'  PBM_GETRANGE = (WM_USER + 7)
  PBM_SETRANGE = (WM_USER + 1)
'  PBM_GETPOS = (WM_USER + 8)
  PBM_SETPOS = (WM_USER + 2)
  PBM_SETSTEP = (WM_USER + 4)
'  PBM_STEPIT = (WM_USER + 5)
  PBM_DELTAPOS = (WM_USER + 3)
'  PBM_SETRANGE32 = (WM_USER + 6)
  PBM_SETBARCOLOR = (WM_USER + 9)
  PBM_SETBKCOLOR = &H2001&
End Enum

Enum AppearanceConstants
  ccFlat
  cc3D
End Enum

Enum BorderStyleConstants
  ccNone
  ccFixedSingle
End Enum

Enum ScrollingConstants
  ccScrollingStandard
  ccScrollingSmooth
End Enum

Enum OrientationConstants
  ccOrientationHorizontal
  ccOrientationVertical
End Enum

Enum ResetColorValue
  '      ?
  '  ,       .
  ResetToDefault = CLR_DEFAULT
End Enum

Private mhWnd As Long, mhWndStatic As Long
Private mAppear As AppearanceConstants, mBS As BorderStyleConstants, mScr As ScrollingConstants, mOrient As OrientationConstants
Private mMin As Single, mMax As Single, mValue As Single, mStep As Single
Private mBackColor As OLE_COLOR, mForeColor As OLE_COLOR

Private Sub UserControl_Initialize()
  mMax = 100
  mValue = 100
  mForeColor = CLR_DEFAULT
  mBackColor = CLR_DEFAULT
  NewBar
End Sub

Property Get Appearance() As AppearanceConstants
Attribute Appearance.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute Appearance.VB_UserMemId = -520
  Appearance = mAppear
End Property

Property Let Appearance(ByVal a As AppearanceConstants)
  Dim tmp As Long
  tmp = GetWindowLong(mhWnd, GWL_EXSTYLE)
  If a = cc3D Then
    If (tmp And WS_EX_CLIENTEDGE) = 0 Then SetWindowLong mhWnd, GWL_EXSTYLE, tmp Or WS_EX_CLIENTEDGE
  Else
    If tmp And WS_EX_CLIENTEDGE Then SetWindowLong mhWnd, GWL_EXSTYLE, tmp And Not WS_EX_CLIENTEDGE
  End If
  SetWindowPos mhWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_NOSIZE
  mAppear = a
End Property

Property Get BorderStyle() As BorderStyleConstants
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BorderStyle.VB_UserMemId = -504
  BorderStyle = mBS
End Property

Property Let BorderStyle(ByVal b As BorderStyleConstants)
  Dim tmp As Long
  tmp = GetWindowLong(mhWnd, GWL_STYLE)
  If b = ccFixedSingle Then
    If (tmp And WS_BORDER) = 0 Then SetWindowLong mhWnd, GWL_STYLE, tmp Or WS_BORDER
  Else
    If tmp And WS_BORDER Then SetWindowLong mhWnd, GWL_STYLE, tmp And Not WS_BORDER
  End If
  SetWindowPos mhWnd, 0, 0, 0, 0, 0, SWP_FRAMECHANGED Or SWP_NOACTIVATE Or SWP_NOMOVE Or SWP_NOOWNERZORDER Or SWP_NOZORDER Or SWP_NOSIZE
  mBS = b
End Property

Property Get Max() As Single
Attribute Max.VB_ProcData.VB_Invoke_Property = ";Behavior"
  Max = mMax
End Property

Property Let Max(ByVal m As Single)
  '     .
  '   MS  :     0,
  '    30000.    
  ',       .
  '   ...
  
  If m < 1 Then Err.Raise 380
  If m < mValue Then mValue = m
  mMax = m
  SendMessage mhWnd, PBM_SETPOS, Adjusted(mValue), ByVal 0&
End Property

Property Get Min() As Single
Attribute Min.VB_ProcData.VB_Invoke_Property = ";Behavior"
  Min = mMin
End Property

Property Let Min(ByVal m As Single)
  If m < 0 Then Err.Raise 380
  If m > mValue Then mValue = m
  mMin = m
  SendMessage mhWnd, PBM_SETPOS, Adjusted(mValue), ByVal 0&
End Property

Property Get Value() As Single
Attribute Value.VB_ProcData.VB_Invoke_Property = ";Behavior"
  Value = mValue
End Property

Property Let Value(ByVal v As Single)
  If v < mMin Then v = mMin
  If v > mMax Then v = mMax
  mValue = v
  SendMessage mhWnd, PBM_SETPOS, Adjusted(mValue), ByVal 0&
End Property

Property Get Scrolling() As ScrollingConstants
Attribute Scrolling.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Scrolling = mScr
End Property

Property Let Scrolling(ByVal s As ScrollingConstants)
  '        .
  ' MSDN ,   ,  SetWindowLong. - ,
  '    ,   .
  '     -    
  '  ,   .
  mScr = s
  NewBar
End Property

Property Get Orientation() As OrientationConstants
Attribute Orientation.VB_ProcData.VB_Invoke_Property = ";Appearance"
  Orientation = mOrient
End Property

Property Let Orientation(ByVal o As OrientationConstants)
  mOrient = o
  NewBar
End Property

Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute BackColor.VB_UserMemId = -501
  BackColor = mBackColor
End Property

Property Let BackColor(ByVal b As OLE_COLOR)
  mBackColor = b
  SendMessage mhWnd, PBM_SETBKCOLOR, 0, ByVal AdjustedColor(mBackColor)
End Property

Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_ProcData.VB_Invoke_Property = ";Appearance"
Attribute ForeColor.VB_UserMemId = -513
  ForeColor = mForeColor
End Property

Property Let ForeColor(ByVal f As OLE_COLOR)
  mForeColor = f
  SendMessage mhWnd, PBM_SETBARCOLOR, 0, ByVal AdjustedColor(mForeColor)
End Property

Property Get Step() As Single
Attribute Step.VB_ProcData.VB_Invoke_Property = ";Behavior"
  Step = mStep
End Property

Property Let Step(ByVal s As Single)
  SendMessage mhWnd, PBM_SETSTEP, Adjusted(s), ByVal 0&
  mStep = s
End Property

Public Sub Increment(Optional ByVal StepsCount As Long = 1)
  If StepsCount < 0 Then Err.Raise 5
  SendMessage mhWnd, PBM_DELTAPOS, Adjusted(mStep) * StepsCount, ByVal 0&
  mValue = mValue + mStep * StepsCount
  If mValue > mMax Then mValue = mMax
End Sub

Public Sub Decrement(Optional ByVal StepsCount As Long = 1)
  If StepsCount < 0 Then Err.Raise 5
  SendMessage mhWnd, PBM_DELTAPOS, -Adjusted(mStep) * StepsCount, ByVal 0&
  mValue = mValue - mStep * StepsCount
  If mValue < mMin Then mValue = mMin
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  With PropBag
    Min = .ReadProperty("Min", 0)
    Max = .ReadProperty("Max", 100)
    Value = .ReadProperty("Value", 100)
    BackColor = .ReadProperty("BackColor", CLR_DEFAULT)
    ForeColor = .ReadProperty("ForeColor", CLR_DEFAULT)
    Appearance = .ReadProperty("Appearance", cc3D)
    BorderStyle = .ReadProperty("BorderStyle", ccFixedSingle)
    Orientation = .ReadProperty("Orientation", ccOrientationHorizontal)
    Scrolling = .ReadProperty("Scrolling", ccScrollingStandard)
    Step = .ReadProperty("Step", 1)
  End With
  InitColors
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  With PropBag
    .WriteProperty "Min", mMin, 0
    .WriteProperty "Max", mMax, 100
    .WriteProperty "Value", mValue, 100
    .WriteProperty "BackColor", mBackColor, CLR_DEFAULT
    .WriteProperty "ForeColor", mForeColor, CLR_DEFAULT
    .WriteProperty "Appearance", mAppear, cc3D
    .WriteProperty "BorderStyle", mBS, ccFixedSingle
    .WriteProperty "Orientation", mOrient, ccOrientationHorizontal
    .WriteProperty "Scrolling", mScr, ccScrollingStandard
    .WriteProperty "Step", mStep, 1
  End With
End Sub

Private Sub UserControl_Resize()
  MoveWindow mhWnd, 0, 0, ScaleWidth, ScaleHeight, 1
End Sub

Private Sub NewBar()
  If mhWnd Then DestroyWindow mhWnd
  mhWnd = CreateWindowEx(IIf(mAppear = cc3D, WS_EX_CLIENTEDGE, 0&), PROGRESS_CLASS, vbNullString, WS_CHILD Or WS_VISIBLE Or WS_CLIPSIBLINGS Or IIf(mBS = ccFixedSingle, WS_BORDER, 0&) Or IIf(mScr = ccScrollingSmooth, PBS_SMOOTH, 0&) Or IIf(mOrient = ccOrientationVertical, PBS_VERTICAL, 0&), 0, 0, ScaleWidth, ScaleHeight, hwnd, 0, App.hInstance, ByVal 0&)
  SendMessage mhWnd, PBM_SETRANGE, 0, ByVal &H75300000
  SendMessage mhWnd, PBM_SETPOS, Adjusted(mValue), ByVal 0&
End Sub

Private Function Adjusted(ByVal v As Single) As Long
  Adjusted = (v - mMin) / (mMax - mMin) * 30000
End Function

Private Function AdjustedColor(ByVal c As OLE_COLOR) As OLE_COLOR
  If c = CLR_DEFAULT Then AdjustedColor = c: Exit Function
  If c And &H80000000 Then AdjustedColor = GetSysColor(c And &H7FFFFFFF) Else AdjustedColor = c
End Function

Private Sub InitColors()
  '     ,     ,
  '    .  .
  ForeColor = ForeColor
  BackColor = BackColor
End Sub
